
----------------------------------------------------------
-- Towers of Hanoi -- Recursive Solution		--
----------------------------------------------------------

class   EvenRing
	inherit Ring

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    make (s : INTEGER) is
	require
	    pos_size:	s >= 2
	    even_size:	(s \\ 2) = 0
	local
	    next : OddRing
	    top : TopRing
        do
            !!io
	    size := s
	    io.put_string ("Creating Ring size = ")
	    io.put_int (size)
	    io.put_string ("%N")
	    if size = 2 then
		!!top.make
		nextRing := top
	    else
		!!next.make (size-1)
		nextRing := next
	    end
        end

-----------------------------------------------------------
    move is
	do
	    nextRing.move
	    doMove("left")
	    nextRing.move
	end

-----------------------------------------------------------
end -- class EvenRing

