
----------------------------------------------------------
-- Towers of Hanoi -- Recursive Solution		--
----------------------------------------------------------

class   StartPole

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO
    bottomRing : EvenRing

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    make (size : INTEGER) is
	require
	    pos_size:   size >= 2
	    even_size:  (size \\ 2) = 0
        do
            !!io
	    io.put_string ("Creating Start Pole%N")
	    !!bottomRing.make (size)
	    io.put_string ("Start Pole Created%N")
        end

-----------------------------------------------------------
    moveRings is
        do
	    bottomRing.move
        end

-----------------------------------------------------------

end -- class StartPole

