
----------------------------------------------------------
-- Towers of Hanoi -- Recursive Solution		--
----------------------------------------------------------

-- if we assume an even number of rings, this will
-- always be an even ring

class   RightRing
	inherit Ring
	    end

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    move is
	do
	    nextRing.move
	    doMove("right")
	    nextRing.move
	end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    -- always even, so never need to make the top ring
    makeNext is
	local
	    next : LeftRing
        do
	    !!next.make (size-1)
	    nextRing := next
        end

-----------------------------------------------------------
end -- class RightRing


