
----------------------------------------------------------
-- Towers of Hanoi -- GENERAL Recursive Solution	--
----------------------------------------------------------

class   LeftRing
	inherit Ring
	end

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    move is
	do
	    nextRing.move
	    doMove("left")
	    nextRing.move
	end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    makeNext is
	local
	    next : RightRing
	    top : TopRightRing
        do
	    if size = 2 then
		!!top.make (size-1)
		nextRing := top
	    else
		!!next.make (size-1)
		nextRing := next
	    end
        end

-----------------------------------------------------------
end -- class LeftRing

