
----------------------------------------------------------
-- Towers of Hanoi -- GENERAL Second solution		--
----------------------------------------------------------

-- implements the nextMove behaviour of the smallest ring

deferred class TopRing
	inherit Ring
	    redefine
		nextMove
	    end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    nextMove is
	do
	    -- move a ring between the other two poles
	    -- stop when both remaining poles are empty
	    if myPole.leftPole.isEmpty and myPole.rightPole.isEmpty
	    then
		io.put_string("STOP%N")
	    elseif myPole.leftPole.topSize < myPole.rightPole.topSize
	    then
	        myPole.leftPole.moveRing
	    else
	        myPole.rightPole.moveRing
	    end
	end

-----------------------------------------------------------
end -- class TopRing

