
class   MAIN

-----------------------------------------------------------
creation {ANY}
	make

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
	io : BASIC_IO
	myStack : MyStack [INTEGER]

-----------------------------------------------------------
	make is
		do
			!!io
			io.put_string ("Making stack%N")
			!!myStack.make(5)
			trypush(10)
			trypush(20)
			trypop
			trypop
			trypop	-- empty stack
			trypush(30)
			trypush(40)
			trypush(50)
			trypush(60)
			trypush(70)
			trypush(80)	-- full stack
		end

	trypush (n : INTEGER) is
		-- try to push a value from myStack
		-- if an error occurs, print a message and continue
		local
			error : BOOLEAN	-- initially False
		do
			if not error
			then
				io.put_string ("Pushing ")
				io.put_int(n)
				io.put_string ("%N")
				myStack.push(n)
				printsize
			end
		rescue
			io.put_string ("ERROR: stack is full%N")
			error := True
			retry
		end

	trypop is
		-- try to pop a value from myStack
		-- if an error occurs, print a message and continue
		local
			top : INTEGER
			error : BOOLEAN	-- initially False
		do
			if not error
			then
				io.put_string ("Popping ")
				top := myStack.top
				io.put_int(top)
				io.put_string ("%N")
				myStack.pop
				printsize
			end
		rescue
			io.put_string ("ERROR: stack is empty%N")
			error := True
			retry
		end

	printsize is
		local
			n : INTEGER
		do
			n := myStack.nb_elements
			io.put_string ("Stack has ")
			io.put_int(n)
			io.put_string (" elements%N")
		end

-----------------------------------------------------------
end -- class MAIN

