
class MyStack [T]
creation { ANY }
	make
feature { NONE }
	contents : ARRAY [T]
	max_size : INTEGER

	make(n :INTEGER) is
		do
			if n>0
			then
				max_size := n
				!!contents.make(1,n)
			end
		end

feature { ANY}
	nb_elements : INTEGER
	empty : BOOLEAN is
		do
			Result := (nb_elements = 0)
		end

	full : BOOLEAN is
		do
			Result := (nb_elements = max_size)
		end

	pop is
		require
			not empty
		do
			nb_elements := nb_elements - 1
		ensure
			not full
			nb_elements = old nb_elements - 1
		end

	top : T is
		require
			not empty
		do
			-- Result := contents.entry(nb_elements)
			Result := contents @ nb_elements
		end

	push (x : T) is
		require
			not full
		do
			nb_elements := nb_elements + 1
			-- contents.enter (nb_elements, x)
			contents.put (x, nb_elements)
		ensure
			not empty
			top = x
			nb_elements = old nb_elements + 1
		end

	invariant
		0 <= nb_elements
		nb_elements <= max_size

end -- class MyStack

