
----------------------------------------------------------
-- Towers of Hanoi -- Recursive Solution		--
----------------------------------------------------------

class   OddRing
	inherit Ring

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    make (s : INTEGER) is
	require
	    pos_size:	s >= 1
	    odd_size:	(s \\ 2) = 1
	local
	    next : EvenRing
        do
            !!io
	    size := s
	    io.put_string ("Creating Ring size = ")
	    io.put_int (size)
	    io.put_string ("%N")
	    if size >= 3 then
		!!next.make (size-1)
		nextRing := next
	    end
        end

-----------------------------------------------------------
    move is
	do
	    nextRing.move
	    doMove("right")
	    nextRing.move
	end

-----------------------------------------------------------

end -- class OddRing



