
----------------------------------------------------------
-- Towers of Hanoi -- GENERAL Recursive Solution	--
----------------------------------------------------------

class   RightRing
	inherit Ring
	    end

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    move is
	do
	    nextRing.move
	    doMove("right")
	    nextRing.move
	end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    makeNext is
	local
	    next : LeftRing
	    top : TopLeftRing
        do
	    if size = 2 then
		!!top.make (size-1)
		nextRing := top
	    elseif size > 2 then
		!!next.make (size-1)
		nextRing := next
	    end
        end

-----------------------------------------------------------
end -- class RightRing


