
----------------------------------------------------------
-- Towers of Hanoi -- GENERAL Recursive Solution	--
----------------------------------------------------------

deferred class Ring

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    move is deferred
	end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO
    size : INTEGER
    nextRing : Ring

-----------------------------------------------------------
    make (s : INTEGER) is
	require
	    pos_size:	s > 0
        do
            !!io
	    size := s
	    io.put_string ("Creating Ring size = ")
	    io.put_int (size)
	    io.put_string ("%N")
	    makeNext
        end

-----------------------------------------------------------
    -- make the next ring, if any
    makeNext is deferred
	end

-----------------------------------------------------------
    -- generic procedure to print out move
    doMove (direction : STRING) is
	do
	    io.put_string ("-- Ring ")
	    io.put_int (size)
	    io.put_string (" moves ")
	    io.put_string (direction)
	    io.put_string ("%N")
	end

-----------------------------------------------------------
end -- class Ring



