
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

deferred class   Ring

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO
    myPole : Pole

-----------------------------------------------------------
    doMove (direction : STRING) is
	do
	    io.put_string ("-- Ring ")
	    io.put_int (size)
	    io.put_string (" moves ")
	    io.put_string (direction)
	    io.put_string ("%N")
	end

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    size : INTEGER

-----------------------------------------------------------
    make (s : INTEGER, p : Pole) is
	require
	    pos_size : s > 0
	    start_pole : p.poleNo = 1
        do
            !!io
	    size := s
	    myPole := p
	    io.put_string ("Creating Ring size = ")
	    io.put_int (size)
	    io.put_string ("%N")
        end

-----------------------------------------------------------
    move is deferred
	end

-----------------------------------------------------------
end -- class Ring

