
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

class   TopRing
	inherit Ring
		rename make as ring_make
		redefine
			move
		end

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {NONE}
-----------------------------------------------------------
	onRingTwo : BOOLEAN

-----------------------------------------------------------
feature {ANY}

-----------------------------------------------------------
    make (s : INTEGER, p : Pole) is
	require
	    top_ring : s = 1
        do
	    ring_make(s, p)
	    onRingTwo := True
        end

-----------------------------------------------------------
    move is
	do
	    doMove("right")
	    myPole := myPole.rightPole
	    myPole.addRing(current)
	    if myPole.leftPole.topSize < myPole.rightPole.topSize
	    then
	        myPole.leftPole.moveRing
	    else
	        myPole.rightPole.moveRing
	    end
	end

-----------------------------------------------------------
end -- class TopRing



