
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

class   TOWERS

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    io : BASIC_IO

-----------------------------------------------------------
feature {ANY}
-----------------------------------------------------------
    p1 : StartPole
    p2, p3 : Pole

-----------------------------------------------------------
    make is
	local
	    rings : INTEGER
        do
            !!io
	    io.put_string ("How many rings to make?%N")
	    io.get_int
	    rings := io.last_int
	    if (rings \\ 2) = 1
	    then
	        io.put_string ("Must be even%N")
	    elseif rings < 2
	    then
	        io.put_string ("Must be positive%N")
	    else
		makePoles
		makeRings(rings)
	    end
	end

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    makePoles is
        do
	    io.put_string ("Creating Poles%N")
	    !!p1.make(1)
	    !!p2.make(2)
	    !!p3.make(3)
	    p1.linkPoles(p3,p2)
	    p2.linkPoles(p1,p3)
	    p3.linkPoles(p2,p1)
	end

-----------------------------------------------------------
    makeRings (n : INTEGER) is
	require
	    pos_rings : n > 0
	    even_rings : (n \\ 2) = 0
	local
	    ringNo : INTEGER
	    even : EvenRing
	    odd : OddRing
	    top : TopRing
        do
	    io.put_string ("Creating Rings%N")
	    from ringNo := n
	    until ringNo = 0
	    loop
	        if ringNo = 1
	        then
		    !!top.make(ringNo,p1)
		    p1.addRing(top)
	        elseif (ringNo \\ 2) = 0
	        then
		    !!even.make(ringNo,p1)
		    p1.addRing(even)
	        else
		    !!odd.make(ringNo,p1)
		    p1.addRing(odd)
	        end
	        ringNo := ringNo - 1
	    end
	    io.put_string ("Towers Created%N")
	    p1.moveRing
        end
    end

-----------------------------------------------------------
end -- class TOWERS


