
----------------------------------------------------------
-- Towers of Hanoi -- Second solution			--
----------------------------------------------------------

-- implements the nextMove behaviour of the smallest ring

class TopRing
	-- assume even number of rings, so always move right
	inherit RightRing
	    redefine nextMove
	    end

-----------------------------------------------------------
creation {ANY}
    make

-----------------------------------------------------------
feature {NONE}

-----------------------------------------------------------
    nextMove is
	do
	    -- move a ring between the other two poles
	    -- stop when both remaining poles are empty
	    if myPole.leftPole.isEmpty and myPole.rightPole.isEmpty
	    then
		io.put_string("STOP%N")
	    elseif myPole.leftPole.topSize < myPole.rightPole.topSize
	    then
	        myPole.leftPole.moveRing
	    else
	        myPole.rightPole.moveRing
	    end
	end

-----------------------------------------------------------
end -- class TopRing

